#include <wx/glcanvas.h>
#include "vector.h"

extern Vector3d contextPos;

class Canvas3D: public wxGLCanvas {
public:
    Canvas3D(wxWindow *parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = "");
	virtual ~Canvas3D();

    void OnPaint(wxPaintEvent& event);
    void OnSize(wxSizeEvent& event);
    void OnEnterWindow(wxMouseEvent& event);
	void OnLeaveWindow(wxMouseEvent& event);

	void mouseMove(wxMouseEvent& event);
	void mouseWheel(wxMouseEvent& event);
	void mouseClick(wxMouseEvent& event);
	void mouseRelease(wxMouseEvent& event);
	void mouseRClick(wxMouseEvent& event);

	void keyPress(wxKeyEvent& evt);
	void keyRelease(wxKeyEvent& evt);

	void createLoc(wxCommandEvent& evt);
	void createCP(wxCommandEvent& evt);
	void createCon(wxCommandEvent& evt);
	void delLoc(wxCommandEvent& evt);
	void delCP(wxCommandEvent& evt);
	void delCon(wxCommandEvent& evt);
	void placeLoc(wxCommandEvent& evt);

    void Render();
    void InitGL();

	wxGLContext* context;

	DECLARE_EVENT_TABLE()
};
