#ifndef CONNECTIONS_INCLUDED
#define CONNECTIONS_INCLUDED

#include <list>
#include <vector>

#include "locations.h"

enum ConType {LAND=0, SEA, RIVER};

class Connection {
public:
	static std::string routeFile;
	static std::list<Connection*> connections;

	static void load(const string& file);
	static void save();
	static Connection* add(Location* a, Location* b);
	static Connection* get(const Location* a, const Location* b);
	static Connection* pick(const Vector3d& pos);	
	static void remove(Connection*);
	static void clear();

	Location *from, *to;
	float distance, modifier;
	unsigned terrainType;	
	ConType type;
	std::vector<Vector3d> via;

	Connection(Location* f, Location* t, float d=0, ConType ty=LAND);
	void draw(bool route=0) const;
	void reverse();
	void insertCP();
	void insertCP(const Vector3d& p);
	void deleteCP(int cp);
	void insertLoc(Location* l);
	Vector3d getClosestPt(const Vector3d& p, int* wpt=0);
	float length();
	int pickControlPoint(const Vector3d& pos);
	float distanceSq(const Vector3d& pos);
	void getCPointsInRect(const Vector3d& min, const Vector3d& max, std::list<Vector3d*>& l);
};

#endif
