#include "glfont.h"
#include "wx/glcanvas.h"
#include <stdio.h>

bool glFont::Initialized=0;
unsigned glFont::Tex=0, glFont::TexWidth=0, glFont::TexHeight=0, glFont::TexStart=0, glFont::TexEnd=0;
glFont::CHAR* glFont::Char=0;

void glFont::Init(char* filename) {
	delete[] Char;

	FILE *Input;
	Input = fopen(filename, "rb");
	if (!Input) return;

	fread(&Tex, sizeof(int), 1, Input);
	fread(&TexWidth, sizeof(int), 1, Input);
	fread(&TexHeight, sizeof(int), 1, Input);
	fread(&TexStart, sizeof(int), 1, Input);
	fread(&TexEnd, sizeof(int), 1, Input);
	fread(&Char, sizeof(CHAR*), 1, Input);

	int Num = TexEnd - TexStart + 1;
	Char = new CHAR[Num];
	fread(Char, sizeof(CHAR), Num, Input);

	Num = TexWidth * TexHeight * 2;
	char *TexBytes = new char[Num];
	fread(TexBytes, sizeof(char), Num, Input);

	unsigned ID;
	glGenTextures(1, &ID);
	Tex=ID;
	glBindTexture(GL_TEXTURE_2D, Tex);
	glTexImage2D(GL_TEXTURE_2D, 0, 2, TexWidth, TexHeight, 0, GL_LUMINANCE_ALPHA, GL_UNSIGNED_BYTE, (void *)TexBytes);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T, GL_CLAMP);
	
	delete []TexBytes;
	fclose(Input);

	Initialized=1;
}

void glFont::Cleanup() {
	delete[] Char;
	glDeleteTextures(1, &Tex);
}

unsigned char ColStr2Int(char col[2]) {
	int d1= 16 * ((col[0]>47 && col[0]<58) ? (col[0]-48) : (col[0]-87));
	return d1 + ((col[1]>47 && col[1]<58) ? (col[1]-48) : (col[1]-87));
}

void glFont::Print(std::string String, float x, float y, float sz, bool right, bool upsideDown) {
	if (!Initialized) return;
	float wFac=sz/Char->height;
	float Tab=sz*2;
	int Length = (int)String.length();
	if (right) {
		float linelength=0;
		for (int i = 0; i < Length; i++) 
			linelength+=Char[(int)String[i] - TexStart].width*wFac;
		x-=linelength;
	}
	float X=x;

	glBindTexture(GL_TEXTURE_2D, Tex);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glBegin(GL_QUADS);
		float DX, DY=sz;
		for (int i = 0; i < Length; i++) {
			if (String[i]=='\n') {x=X; y+=DY; continue;}
			if (String[i]=='\t') {
				x=Tab+(int)(x/Tab)*Tab; continue;}
			if (String[i]=='^') {
				char val[2];
				val[0]=String[++i];
				val[1]=String[++i];
				unsigned char r=ColStr2Int(val);
				val[0]=String[++i];
				val[1]=String[++i];
				unsigned char g=ColStr2Int(val);
				val[0]=String[++i];
				val[1]=String[++i];
				unsigned char b=ColStr2Int(val);
				glColor3ub(r,g,b);					
				continue;
			}

			CHAR *Ch = &Char[(int)String[i] - TexStart];
			DX=Ch->width*wFac;

			float ty1 = upsideDown ? Ch->ty2 : Ch->ty1;
			float ty2 = upsideDown ? Ch->ty1 : Ch->ty2;

			glTexCoord2f(Ch->tx1, ty1);
			glVertex3f(x, y, 0);
			glTexCoord2f(Ch->tx1, ty2);
			glVertex3f(x, y + DY, 0);
			glTexCoord2f(Ch->tx2, ty2);
			glVertex3f(x + DX, y + DY, 0);
			glTexCoord2f(Ch->tx2, ty1);
			glVertex3f(x + DX, y, 0);
			x += DX;
		}
	glEnd();
}
