#include "maptool.h"
#include <tinyxml.h>

vector<TerrainType> TerrainType::terrains;

void TerrainType::load(const string& file) {
	TiXmlDocument xml(file.c_str());
	if (xml.LoadFile()) {
		terrains.clear();

		TiXmlElement* root=xml.RootElement();
		TiXmlElement* e = root->FirstChildElement("terrain");

		while (e) {
			terrains.push_back( TerrainType(e->Attribute("name")) );

			e->QueryFloatAttribute("mod", &terrains.back().mod);
			e->QueryIntAttribute("id", &terrains.back().id);
			e=e->NextSiblingElement("terrain");
		}
	}
}

TerrainType* TerrainType::get(const string& name) {
	for (unsigned i=0; i<terrains.size(); i++)
		if (terrains[i].name==name) return &terrains[i];

	return 0;
}
