#include "maptool.h"
#include <tinyxml.h>

vector<Transportation> Transportation::transports;

void Transportation::load(const string& file) {
	TiXmlDocument xml(file.c_str());
	if (xml.LoadFile()) {
		transports.clear();

		TiXmlElement* root=xml.RootElement();
		TiXmlElement* e = root->FirstChildElement("trans");
		while (e) {
			const char* t = e->Attribute("type");
			if (t) {
				Transportation trans(e->Attribute("name"));
				e->QueryFloatAttribute("speed", &trans.speed);
				trans.revSpeed=trans.speed;
				e->QueryFloatAttribute("speedUpstream", &trans.revSpeed);
				e->QueryFloatAttribute("fastFactor", &trans.fastFac);
				e->QueryValueAttribute("impassable", &trans.excludedTerrain);
				e->QueryValueAttribute("standard", &trans.allowed);
				
				string tr=t;
				if (tr=="sea") trans.type=SEA;
				if (tr=="land") trans.type=LAND;
				if (tr=="river") trans.type=RIVER;
				transports.push_back(trans);
			}
			e=e->NextSiblingElement("trans");
		}
	}
}
